package fileio;
import java.awt.Component;
import java.io.File;
import java.lang.*;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;
import laf.CommandMap;

//--------------------------------------------------------------------//
/**
 * t@CڑANV
 */
public abstract class FileAccessAction extends AbstractAction{

/** JgfBNg */
  protected static File currentDirectory=new File(".");

/** [UI\ȃt@CtB^i[z */
  protected FileFilter filters[];

/**
 * ANVIuWFNg\z
 */
  protected FileAccessAction(){
    filters=getFileFilters();
  }

/**
 * ACRw肵ăANVIuWFNg\z
 * @param icon ACR
 */
  protected FileAccessAction(Icon icon){
    putValue(SMALL_ICON,icon);
    filters=getFileFilters();
  }

//--------------------------------------------------------------------//
/**
 * [UI\ȃt@CtB^i[zԂ
 * @return [UI\ȃt@CtB^
 */
  protected abstract FileFilter[] getFileFilters();

/**
 * _CAȌL҂Ԃ
 * @return _CAOL Component
 */
  protected abstract Component getDialogOwner();

//--------------------------------------------------------------------//
/**
 * t@CI_CAOԂ
 * @return t@CI_CAO
 */
  protected JFileChooser getFileChooser(){
    JFileChooser fileChooser=new JFileChooser(currentDirectory);
    fileChooser.setFileSelectionMode
      (JFileChooser.FILES_AND_DIRECTORIES);
    for(int i=0;i<filters.length;i++){
      fileChooser.addChoosableFileFilter(filters[i]);
    }
    return fileChooser;
  }

//--------------------------------------------------------------------//
/**
 * t@CC
 * @param file ̃t@C
 * @param filter t@CI_CAOőIꂽt@CtB^
 * @return Cꂽt@C
 */
  protected File modifiedFile(File file,FileFilter filter){
    return file;
  }

//--------------------------------------------------------------------//
/**
 * G[bZ[W\
 * @param message G[ʒmbZ[W
 * @param ex O
 */
  protected void showErrorMessage(String message,Exception ex){
    String error[]={message,ex.toString()};
    JOptionPane.showMessageDialog
      (getDialogOwner(),error,CommandMap.get(CommandMap.CAUTION),
       JOptionPane.ERROR_MESSAGE);
  }
}
