package gui.print;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.lang.*;
import javax.print.DocFlavor;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import javax.swing.JOptionPane;
import laf.CommandMap;

//--------------------------------------------------------------------//
/**
 * ANV
 */
public abstract class PrintAction extends AbstractAction{

/** _CAȌL */
  protected Component base;

/** ǗIuWFNg */
  protected PrintManager manager;

/**
 * ANVIuWFNg\z
 * @param base _CAȌL
 */
  public PrintAction(Component base){
    putValue(NAME,actionName());
    this.base=base;
    manager=new PrintManager(getDocFlavor());
  }

/**
 * ACRw肵ăANVIuWFNg\z
 * @param base _CAȌL
 * @param icon ACR
 */
  public PrintAction(Component base,Icon icon){
    putValue(SMALL_ICON,icon);
    putValue(SHORT_DESCRIPTION,actionName());
    this.base=base;
    manager=new PrintManager(getDocFlavor());
  }

//--------------------------------------------------------------------//
/**
 * f[^`Ԃ
 * @return f[^`
 */
  protected abstract DocFlavor getDocFlavor();

/**
 * Ώۃf[^Ԃ
 * @return Ώۃf[^
 */
  protected abstract Object getPrintData();

//--------------------------------------------------------------------//
/**
 * ݒ肵Ĉ
 * @param e ANVƂCxg
 */
  public void actionPerformed(ActionEvent e){
    if(manager.showDialog()){
      try{
      	manager.print(getPrintData());
      }
      catch(Exception ex){
      	showErrorMessage("print error",ex);
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * G[bZ[W\
 * @param message G[ʒmbZ[W
 * @param ex O
 */
  protected void showErrorMessage(String message,Exception ex){
    String error[]={message,String.valueOf(ex)};
    JOptionPane.showMessageDialog
      (base,error,"Caution",JOptionPane.WARNING_MESSAGE);
  }

//--------------------------------------------------------------------//
/**
 * ANV̂Ԃ
 * @return ANV
 */
  public static String actionName(){
    return CommandMap.get(CommandMap.PRINT);
  }
}
