package gui.transfer;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.Transferable;
import java.awt.event.ActionEvent;
import java.lang.*;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import laf.CommandMap;

//--------------------------------------------------------------------//
/**
 * f[^Nbv{[hɃRs[ANV
 */
public class CopyAction extends AbstractAction{

/** ftHg̃c[Lbg */
  private static final Toolkit
    DEFAULT_TOOLKIT=Toolkit.getDefaultToolkit();

/** Rs[f[^ */
  private TransferableData data;

/**
 * ANVIuWFNg\z
 * @param data Rs[f[^
 */
  public CopyAction(TransferableData data){
    putValue(NAME,actionName());
    this.data=data;
  }

/**
 * ACRw肵ăANVIuWFNg\z
 * @param data Rs[f[^
 * @param icon ACR
 */
  public CopyAction(TransferableData data,Icon icon){
    putValue(SMALL_ICON,icon);
    putValue(SHORT_DESCRIPTION,actionName());
    this.data=data;
  }

//--------------------------------------------------------------------//
/**
 * f[^Nbv{[hɃRs[
 * @param e ANVƂCxg
 */
  public void actionPerformed(ActionEvent e){
    copy(data);
  }

//--------------------------------------------------------------------//
/**
 * f[^Nbv{[hɃRs[
 * @param data Rs[f[^
 */
  public static void copy(TransferableData data){
    copy(data.getContext());
  }

//--------------------------------------------------------------------//
/**
 * f[^Nbv{[hɃRs[
 * @param transferable ]̂߂ <code>Transferable</code>
 *                     IuWFNg
 */
  public static void copy(Transferable transferable){
    Clipboard clipboard=DEFAULT_TOOLKIT.getSystemClipboard();
    clipboard.setContents(transferable,null);
  }

//--------------------------------------------------------------------//
/**
 * ANV̂Ԃ
 * @return ANV
 */
  public static String actionName(){
    return CommandMap.get(CommandMap.COPY);
  }
}
