package laf;
import java.io.InputStream;
import java.io.IOException;
import java.lang.*;
import java.net.URL;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;
import resourcemanager.WordManager;
import resourcemanager.XMLDataMap;

//--------------------------------------------------------------------//
/**
 * gpPǗNX
 */
public class WordMap extends XMLDataMap{

/** ^Cg\ */
  public static final String TITLE="title";

/** \ݒ\ */
  public static final String VIEW_SETTING="viewsetting";

/** ͈͂\ */
  public static final String AREA="area";

/** _\ */
  public static final String DOT="dot";

/** CύXbN\ */
  public static final String OCEAN_LOCK="oceanlock";

/** g\ */
  public static final String ZOOM_IN="zoomin";

/** k\ */
  public static final String ZOOM_OUT="zoomout";

/** ̈\ */
  public static final String REGION="region";

/** ̈於\ */
  public static final String REGION_NAME="regionname";

/** \F\ */
  public static final String COLOR="color";

/** VK쐬\ */
  public static final String NEW_PART="newpart";

/** Đݒ\ */
  public static final String REPLACE="replace";

/** 폜\ */
  public static final String DELETE="delete";

/** o[W\ */
  public static final String VERSION1="version1";

/** o[W\ */
  public static final String VERSION2="version2";

/** o[W\ */
  public static final String VERSION3="version3";

/** o[W\ */
  public static final String VERSION4="version4";

/** f[^i[}bv */
  private static WordMap current=new WordMap();

/**
 * gpPǗIuWFNg\z
 */
  public WordMap(){
    super();
  }

//--------------------------------------------------------------------//
/**
 * gpPǂݍ
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read()
    throws ParserConfigurationException,SAXException,IOException{
    read(WordManager.get());
  }

//--------------------------------------------------------------------//
/**
 * gpPǂݍ
 * @param language 
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read(String language)
    throws ParserConfigurationException,SAXException,IOException{
    if(language.equals(DrawParameter.JAPANESE)){
      read(WordManager.get(WordManager.J_FILE_NAME));
    }
    else{
      read(WordManager.get());
    }
  }

//--------------------------------------------------------------------//
/**
 * gpPǂݍ
 * @param url f[^ URL
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read(URL url)
    throws ParserConfigurationException,SAXException,IOException{
    current.readFromURL(url);
  }

//--------------------------------------------------------------------//
/**
 * gpPǂݍ
 * @param is ̓Xg[
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read(InputStream is)
    throws ParserConfigurationException,SAXException,IOException{
    current.readFromStream(is);
  }

//--------------------------------------------------------------------//
/**
 * gpPԂ
 * @param key P̃L[
 * @return P
 */
  public static String get(String key){
    return current.getName(key);
  }
}
