package worldmap;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.lang.*;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import laf.WordMap;

//--------------------------------------------------------------------//
/**
 * }bv̈惊Xgpl
 */
public class RegionListPanel extends JPanel{

/** n}\t[ */
  private WorldMapFrame frame;

/**
 * }bv̈惊Xgpl\z
 * @param frame n}\t[
 */
  public RegionListPanel(WorldMapFrame frame){
    super();
    this.frame=frame;

    setLayout(new BorderLayout());
    JPanel buttonPanel=new JPanel();
    buttonPanel.setLayout(new GridLayout(3,1));

    add(new JScrollPane(frame.getRegionList()),BorderLayout.CENTER);

    buttonPanel.add(new JButton(new AddNewPartAction()));
    buttonPanel.add(new JButton(new ReplacePartAction()));
    buttonPanel.add(new JButton(new DeletePartAction()));
    add(buttonPanel,BorderLayout.SOUTH);
  }

//--------------------------------------------------------------------//
/**
 * ̈ǉANV
 */
  public class AddNewPartAction extends AbstractAction{

/**
 * ANV\z
 */
    public AddNewPartAction(){
      putValue(NAME,WordMap.get(WordMap.NEW_PART));
    }

//--------------------------------------------------------------------//
/**
 * ̈ǉ
 * @param e ANVƂCxg
 */
    public void actionPerformed(ActionEvent e){
      RegionList list=frame.getRegionList();
      Region region=RegionDialog.showDialog
      	(frame,list.getSelectedRegion());
      if(region!=null){
      	list.addRegion(region);
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * ̈uANV
 */
  public class ReplacePartAction extends AbstractAction{

/**
 * ANV\z
 */
    public ReplacePartAction(){
      putValue(NAME,WordMap.get(WordMap.REPLACE));
    }

//--------------------------------------------------------------------//
/**
 * ̈u
 * @param e ANVƂCxg
 */
    public void actionPerformed(ActionEvent e){
      RegionList list=frame.getRegionList();
      Region region=list.getSelectedRegion();
      if(region==null) return;
      region=RegionDialog.showDialog(frame,region);
      if(region!=null){
      	list.setRegion(region);
      	frame.getPanel().repaint();
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * ̈폜ANV
 */
  public class DeletePartAction extends AbstractAction{

/**
 * ANV\z
 */
    public DeletePartAction(){
      putValue(NAME,WordMap.get(WordMap.DELETE));
    }

//--------------------------------------------------------------------//
/**
 * ̈폜
 * @param e ANVƂCxg
 */
    public void actionPerformed(ActionEvent e){
      RegionList list=frame.getRegionList();
      if(list.getSelectedIndex()>0){
      	list.removeRegion();
      	frame.getPanel().repaint();
      }
    }
  }
}
