package fileio;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Reader;
import java.io.Writer;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * eLXgf[^o͂̒ۃX[p[NX
 */
public abstract class TextDataIO extends DataIO{

  protected TextDataIO(){
    super();
  }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param name f[^
 * @param br ̓[_[
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  public abstract void readData(String name,BufferedReader br)
    throws Exception;

/**
 * f[^
 * @param pw o̓C^[
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  public abstract void writeData(PrintWriter pw) throws Exception;

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param name f[^
 * @param reader ̓[_[
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  public void read(String name,Reader reader) throws Exception{
    BufferedReader br=new BufferedReader(reader);
    readData(name,br);
    br.close();
  }

//--------------------------------------------------------------------//
/**
 * f[^
 * @param writer o̓C^[
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  public void write(Writer writer) throws Exception{
    PrintWriter pw=new PrintWriter(new BufferedWriter(writer));
    writeData(pw);
    pw.close();
  }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param name f[^
 * @param is ̓Xg[
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  public void read(String name,InputStream is) throws Exception{
    read(name,new InputStreamReader(is));
  }

//--------------------------------------------------------------------//
/**
 * t@Cf[^ǂݍ
 * @param file t@C
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  public void read(File file) throws Exception{
    FileReader reader=new FileReader(file);
    read(file.getName(),reader);
    if(reader!=null) reader.close();
  }

//--------------------------------------------------------------------//
/**
 * f[^Ƀf[^
 * @param os o̓Xg[
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  public void write(OutputStream os) throws Exception{
    write(new OutputStreamWriter(os));
  }

//--------------------------------------------------------------------//
/**
 * t@CɃf[^
 * @param file t@C
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  public void write(File file) throws Exception{
    FileWriter writer=new FileWriter(file);
    write(writer);
    writer.close();
  }

//--------------------------------------------------------------------//
/**
 * 𕪊
 * @param s 镶
 * @return i[z
 */
  public static String[] split(String s){
    String ss[]=s.split("\\s+");
    if((ss.length==0) || !ss[0].equals("")){
      return ss;
    }
    else{
      String ss2[]=new String[ss.length-1];
      System.arraycopy(ss,1,ss2,0,ss.length-1);
      return ss2;
    }
  }
}
