package gui;
import java.awt.event.ActionEvent;
import java.lang.*;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import laf.CommandMap;

//--------------------------------------------------------------------//
/**
 * tHgTCYύXANV
 */
public class FontResizeAction extends AbstractAction{

/** tHgTCYύXIuWFNg */
  protected FontResizeable comp;

/** tHgTCYύX */
  protected int dsize;

/**
 * ANVIuWFNg\z
 * @param comp tHgTCYύXIuWFNg
 * @param dsize tHgTCYύX
 */
  public FontResizeAction(FontResizeable comp,int dsize){
    putValue(NAME,actionName(dsize));
    this.comp=comp;
    this.dsize=dsize;
  }

/**
 * ACRw肵ăANVIuWFNg\z
 * @param comp tHgTCYύXIuWFNg
 * @param dsize tHgTCYύX
 * @param icon ACR
 */
  public FontResizeAction(FontResizeable comp,int dsize,Icon icon){
    putValue(SMALL_ICON,icon);
    putValue(SHORT_DESCRIPTION,actionName(dsize));
    this.comp=comp;
    this.dsize=dsize;
  }

//--------------------------------------------------------------------//
/**
 * f[^Nbv{[hɃRs[
 * @param e ANVƂCxg
 */
  public void actionPerformed(ActionEvent e){
    comp.resizeFont(dsize);
  }

//--------------------------------------------------------------------//
/**
 * ANV̂Ԃ
 * @param dsize tHgTCYύX
 * @return ANV
 */
  public static String actionName(int dsize){
    StringBuffer sb=new StringBuffer();
    sb.append(CommandMap.get(CommandMap.FONT_SIZE));
    sb.append(' ');
    if(dsize>0) sb.append('+');
    sb.append(dsize);
    return sb.toString();
  }
}
