package gui;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.lang.*;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import laf.CommandMap;

//--------------------------------------------------------------------//
/**
 * EBhEBANV
 */
public class WindowHideAction extends AbstractAction{

/** ΏۃEBhE */
  private Component win;

/**
 * ANVIuWFNg\z
 * @param win ΏۃEBhE
 */
  public WindowHideAction(Component win){
    putValue(NAME,actionName());
    this.win=win;
  }

/**
 * ACRw肵ăANVIuWFNg\z
 * @param win ΏۃEBhE
 * @param icon ACR
 */
  public WindowHideAction(Component win,Icon icon){
    putValue(SMALL_ICON,icon);
    putValue(SHORT_DESCRIPTION,actionName());
    this.win=win;
  }

//--------------------------------------------------------------------//
/**
 * EBhEB
 * @param e ANVƂCxg
 */
  public void actionPerformed(ActionEvent e){
    win.setVisible(false);
  }

//--------------------------------------------------------------------//
/**
 * ANV̂Ԃ
 * @return ANV
 */
  public static String actionName(){
    return CommandMap.get(CommandMap.HIDE);
  }

//--------------------------------------------------------------------//
/**
 * EBhEBANV
 */
  public static class WinHideEventHandler extends WindowAdapter{

/** ΏۃEBhE */
    private Component win;

/**
 * IuWFNg\z
 * @param win ΏۃEBhE
 */
    public WinHideEventHandler(Component win){
      this.win=win;
    }

//--------------------------------------------------------------------//
/**
 * EBhEB
 * @param e ANVƂCxg
 */
    public void windowClosing(WindowEvent e){
      win.setVisible(false);
    }
  }
}
